<?php
if (!class_exists('vBShop_Item_Core'))
{
	die('No direct access allowed.');
}

class vBShop_Item_deletethread extends vBShop_Item_Core
{
	/**
	* The constructor
	*
	* @param	vBulletin	vBulletin registry
	* @param	array		Item info
	*/	
	public function __construct(&$registry, &$item)
	{
		parent::__construct($registry, $item);
		
		// Set purchase template
		$this->config['purchasetemplate'] = 'dbtech_vbshop_configure_deletethread';

		require_once(DIR . '/includes/functions_databuild.php');		
	}
	
	/**
	* Function to call before every action
	*/	
	public function action()
	{
		if (!parent::action())
		{
			// This type is inactive
			return false;
		}
		
		// We made it!
		return true;
	}
	
	/**
	* Prints out an AdminCP form
	*/	
	public function print_admin_form($code)
	{
		global $vbphrase;

		print_forum_chooser($vbphrase['dbtech_vbshop_excluded_forums'], 'item[code][excluded][]', $code['excluded'], NULL, true, true);
		print_yes_no_row($vbphrase['dbtech_vbshop_own_threads_only'], 'item[code][onlyown]', $code['onlyown']);
	}
	
	/**
	* Activate an item
	*
	* @param	integer		Purchase ID
	* @param	mixed		Recipient
	*/	
	public function activate($purchaseid, $recipient = NULL, $dorebuild = true)
	{
		if (!parent::activate($purchaseid, $recipient, $dorebuild))
		{
			// Couldn't deactivate
			return false;
		}

		if (!$this->config['configuration']['threadid'])
		{
			// Nothin configured
			return true;
		}

		$threadinfo = fetch_threadinfo($this->config['configuration']['threadid']);
		if (!$threadinfo OR in_array($threadinfo['forumid'], $this->config['code']['excluded']))
		{
			// Excluded forum
			return true;
		}

		if ($threadinfo['postuserid'] != $this->registry->userinfo['userid'] AND $this->config['code']['onlyown'])
		{
			// We can only delete own threads
			return true;
		}

		if (!$this->purchaseinfo)
		{
			if (!$this->purchaseinfo = $this->registry->db->query_first_slave("
				SELECT *
				FROM " . TABLE_PREFIX . "dbtech_vbshop_purchase
				WHERE purchaseid = " . intval($purchaseid)
			))
			{
				// Purchase didn't exist
				return false;
			}
		}	

		// Grab this
		$this->purchaseinfo['username'] = VBSHOP::$db->fetchOne('SELECT username FROM $user WHERE userid = ?', array($this->purchaseinfo['userid']));

		// Now we need this
		$foruminfo = fetch_foruminfo($threadinfo['forumid']);

		$physicaldel = false;
		$delinfo = array(
			'userid'          => $this->purchaseinfo['userid'],
			'username'        => $this->purchaseinfo['username'],
			'reason'          => 'purchase id: ' . $purchaseid,
			'keepattachments' => 1
		);

		$threadman =& datamanager_init('Thread', $this->registry, ERRTYPE_SILENT, 'threadpost');
			$threadman->set_existing($threadinfo);
		$threadman->delete($foruminfo['countposts'], $physicaldel, $delinfo);
		unset($threadman);

		build_forum_counters($threadinfo['forumid']);		
		
		return true;
	}

	/**
	* Deactivate an item
	*
	* @param	integer		Purchase ID
	* @param	mixed		Recipient
	*/	
	public function deactivate($purchaseid, $recipient = null, $dorebuild = true)
	{
		if (!parent::deactivate($purchaseid, $recipient, $dorebuild))
		{
			// Couldn't deactivate
			return false;
		}

		if (!$this->config['configuration']['threadid'])
		{
			// Nothin configured
			return true;
		}

		$threadinfo = fetch_threadinfo($this->config['configuration']['threadid']);
		if (!$threadinfo OR in_array($threadinfo['forumid'], $this->config['code']['excluded']))
		{
			// Excluded forum
			return true;
		}

		if ($threadinfo['postuserid'] != $this->registry->userinfo['userid'] AND $this->config['code']['onlyown'])
		{
			// We can only delete own threads
			return true;
		}

		// Now we need this
		$foruminfo = fetch_foruminfo($threadinfo['forumid']);

		// Set username style
		undelete_thread($threadinfo['threadid'], $foruminfo['countposts']);
		
		return true;
	}	
	
	/**
	* Configure an item
	*
	* @param	integer		Purchase ID
	* @param	mixed		Recipient
	*/	
	public function configure($purchaseid, $recipient = null)
	{
		global $vbphrase;
		
		if (!$this->can_configure($purchaseid))
		{
			// Can't configure this item
			return false;
		}
		
		// Ensure this is set
		$recipient = (!$recipient ? $this->registry->userinfo : $recipient);
		
		// Get the form code
		$code 			= $this->registry->input->clean_gpc('p', 'code', 			TYPE_ARRAY);
		$noConfigure 	= $this->registry->input->clean_gpc('p', '_noConfigure', 	TYPE_BOOL);
		
		if ($noConfigure)
		{
			// We're done, we wanted to let the recipient configure it themselves
			return true;
		}

		if ($code['threadid'])
		{
			$threadinfo = fetch_threadinfo($code['threadid']);
			if (!$threadinfo OR in_array($threadinfo['forumid'], $this->config['code']['excluded']))
			{
				// Excluded forum
				eval(standard_error(fetch_error('dbtech_vbshop_invalid_data', $vbphrase['dbtech_vbshop_thread_id'])));
			}

			if ($threadinfo['postuserid'] != $this->registry->userinfo['userid'] AND $this->config['code']['onlyown'])
			{
				// We can only delete own threads
				eval(standard_error(fetch_error('dbtech_vbshop_invalid_data', $vbphrase['dbtech_vbshop_thread_id'])));
			}

			if ($this->config['configuration']['threadid'] != $code['threadid'] AND $threadinfo['visible'] == 2)
			{
				// Already deleted
				eval(standard_error(fetch_error('dbtech_vbshop_invalid_data', $vbphrase['dbtech_vbshop_thread_id'])));
			}

			if ($this->config['configuration']['threadid'] != $code['threadid'] AND $this->config['configuration']['threadid'])
			{
				// Undelete old thread
				$threadinfo2 = fetch_threadinfo($this->config['configuration']['threadid']);
				$foruminfo2 = fetch_foruminfo($threadinfo2['forumid']);

				// Set username style
				undelete_thread($threadinfo2['threadid'], $foruminfo2['countposts']);
			}

			if (!$this->purchaseinfo)
			{
				if (!$this->purchaseinfo = $this->registry->db->query_first_slave("
					SELECT *
					FROM " . TABLE_PREFIX . "dbtech_vbshop_purchase
					WHERE purchaseid = " . intval($purchaseid)
				))
				{
					// Purchase didn't exist
					return false;
				}
			}	

			// Grab this
			$this->purchaseinfo['username'] = VBSHOP::$db->fetchOne('SELECT username FROM $user WHERE userid = ?', array($this->purchaseinfo['userid']));

			// Now we need this
			$foruminfo = fetch_foruminfo($threadinfo['forumid']);

			$physicaldel = false;
			$delinfo = array(
				'userid'          => $this->purchaseinfo['userid'],
				'username'        => $this->purchaseinfo['username'],
				'reason'          => 'purchase id: ' . $purchaseid,
				'keepattachments' => 1
			);

			$threadman =& datamanager_init('Thread', $this->registry, ERRTYPE_SILENT, 'threadpost');
				$threadman->set_existing($threadinfo);
			$threadman->delete($foruminfo['countposts'], $physicaldel, $delinfo);
			unset($threadman);

			build_forum_counters($threadinfo['forumid']);
		}
		else
		{
			if ($this->config['configuration']['threadid'])
			{
				$threadinfo = fetch_threadinfo($this->config['configuration']['threadid']);
				$foruminfo = fetch_foruminfo($threadinfo['forumid']);

				if ($threadinfo['postuserid'] != $this->registry->userinfo['userid'] AND $this->config['code']['onlyown'])
				{
					// We can only delete own threads
					eval(standard_error(fetch_error('dbtech_vbshop_invalid_data', $vbphrase['dbtech_vbshop_thread_id'])));
				}

				// Set username style
				undelete_thread($threadinfo['threadid'], $foruminfo['countposts']);
			}
		}

		if ($this->config['notifications_config'])
		{
			$userids = explode(',', $this->config['notifications_config']);
			foreach ((array)$userids as $userid)
			{
				// Send PM
				VBSHOP::sendPM(
					$userid,
					construct_phrase($vbphrase['dbtech_vbshop_new_configuration_x'],
						$this->config['title']
					),
					construct_phrase($vbphrase['dbtech_vbshop_x_just_configured_y'],
						$recipient['username'],
						$this->config['title'],
						$vbphrase['dbtech_vbshop_thread_id'] . ': ' . intval($code['threadid'])
					)
				);
			}
		}
		
		// Update flag
		$this->registry->db->query_write("
			UPDATE " . TABLE_PREFIX . "dbtech_vbshop_purchase
			SET configuration = " . $this->registry->db->sql_prepare(trim(serialize($code))) . "
			WHERE purchaseid = " . intval($purchaseid) . "
		");
		
		// Build purchase cache
		VBSHOP::build_purchases($recipient);				
	}	
}
?>